
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Python面向对象编程指南》——1.12　更多的__init__()技术 / iVAN</title>

    <meta name="description" content="《Python面向对象编程指南》——1.12　更多的__init__()技术 1.12 更多的__init__()技术 我们再来看一下其他一些更高级的__init__()技术的应用.相比前面的介绍,它们的应用场景不是特别常见. 以下是Player类的定义,初始化使用了两个策略对象和一个table对象.这个__init__()函数看起来不够漂亮. class Player: def __init__( self, table, bet_strategy, game_strategy ): self.bet_strategy = bet_strategy self.game_">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Python面向对象编程指南》——1.12　更多的__init__()技术</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1.12　更多的__init__()技术</h3>
<p>我们再来看一下其他一些更高级的__init__()技术的应用。相比前面的介绍，它们的应用场景不是特别常见。</p>
<p>以下是Player类的定义，初始化使用了两个策略对象和一个table对象。这个__init__()函数看起来不够漂亮。</p>
<pre><code>class Player:
 　　def __init__( self, table, bet_strategy, game_strategy ):
 　　　　self.bet_strategy = bet_strategy
 　　　　self.game_strategy = game_strategy
 　　　　self.table= table
 　　def game( self ):
 　　　　self.table.place_bet( self.bet_strategy.bet() )
 　　　　self.hand= self.table.get_hand()
 　　　　if self.table.can_insure( self.hand ):
 　　　　　　if self.game_strategy.insurance( self.hand ):
 　　　　　　　　self.table.insure( self.bet_strategy.bet() )
 　　　　# Yet more... Elided for now</code></pre>
<p>Player类中的__init__()函数的行为似乎仅仅是保存对象。代码逻辑只是把参数的值复制到同样名称的变量中。如果我们有很多参数，复制逻辑会显得臃肿且重复。</p>
<p>我们可以像如下代码这样使用这个Player类（和相关对象）。</p>
<pre><code>table = Table()
flat_bet = Flat()
dumb = GameStrategy()
p = Player( table, flat_bet, dumb )
p.game()</code></pre>
<p>我们可以通过把关键字参数值直接转换为内部变量，以提供一个非常短而且灵活的初始化方式。</p>
<p>以下是一种使用关键字参数值来创建Player类的方式。</p>
<pre><code>class Player2:
 　　def __init__( self, **kw ):
 　　　　"""Must provide table, bet_strategy, game_strategy."""
 　　　　self.__dict__.update( kw )
 　　def game( self ):
 　　　　self.table.place_bet( self.bet_strategy.bet() )
 　　　　self.hand= self.table.get_hand()
 　　　　if self.table.can_insure( self.hand ):
 　　　　　　if self.game_strategy.insurance( self.hand ):
 　　　　　　　　self.table.insure( self.bet_strategy.bet() )
 　　　　# etc.</code></pre>
<p>为了换来简洁的代码，这种实现方式牺牲了大量的可读性。它使得代码意图变得模糊。</p>
<p>既然__init__()函数缩减到了一行，函数的很多多余的重复逻辑也被拿掉了。然而这种多余也被转化为对象各自的构造函数表达式。既然我们不再使用位置参数，那么我们就需要为对象初始化表达式提供参数名，如以下代码段所示。</p>
<pre><code>p2 = Player2( table=table, bet_strategy=flat_bet, game_strategy=dumb )</code></pre>
<p>为什么这样做？</p>
<p>这样的类设计非常容易扩展，我们几乎不用担心是否需要传入额外的参数给构造函数。</p>
<p>以下是调用的例子。</p>
<pre><code>&gt;&gt;&gt; p1= Player2( table=table, bet_strategy=flat_bet, game_
strategy=dumb)
&gt;&gt;&gt;p1.game()</code></pre>
<p>以下代码演示了这个设计带来的可扩展性。</p>
<pre><code>&gt;&gt;&gt; p2= Player2( table=table, bet_strategy=flat_bet, game_
strategy=dumb, log_name="Flat/Dumb" )
&gt;&gt;&gt;p2.game()</code></pre>
<p>我们添加了一个log_name属性而并不需要修改类定义，这个属性或许可以用来进行统计分析。Player2.log_name属性可以用于日志的注解或其他数据。</p>
<p>这里存在一个限制，我们只可以添加类内部不会发生冲突的参数名。在创建子类时需要了解类的实现，以避免关键字参数名冲突。由于**kw参数提供了很少的信息，我们不得不去知道它的实现细节。可在大多数情况下，我们要相信一个类并使用它而不是去查看它的实现细节。</p>
<p>这种基于关键字的初始化可以放在基类中实现，以简化子类。当新需求导致需要添加参数时，我们不必在每个子类中都实现一个__init__()函数。</p>
<p>这种实现方式的弊端在于存在一些变量在子类中没有提供文档说明。当仅需要添加一个变量时，可能需要改变整个类层次结构。第1个变量添加之后往往还会需要第2个和第3个。在设计的开始，我们应当考虑设计一些灵活的子类，而不是完美的基类。</p>
<p>我们可以（而且应该）像下面代码段那样同时使用位置变量和关键字变量。</p>
<pre><code>class Player3( Player ):
 　　def __init__( self, table, bet_strategy, game_strategy, **extras
):
 　　　　self.bet_strategy = bet_strategy
 　　　　self.game_strategy = game_strategy
 　　　　self.table= table
 　　　　self.__dict__.update( extras )</code></pre>
<p>这种方式看起来比完全开放的定义更明智。我们把必需的参数设为位置参数，把可选参数通过关键字参数传入。这也演示了如何通过 extra关键字参数把可选参数传入__init__()函数。</p>
<p>这样的灵活性，基于关键字的初始化依赖于我们是否已经定义了相对透明的类。这种实现需要特别关注一下命名，因为关键字参数名是开放式的，要避免调试过程中发生命名冲突。</p>
<h3>1.12.1　带有类型验证的初始化</h3>
<p>需要类型验证的场景很少。从某种程度上说，这是对Python的误解。从概念上来看，类型验证是为了验证所有的参数类型是恰当的类型，而这里对“恰当”的定义往往作用不大。</p>
<p>这和验证对象是否符合其他标准是不同的，例如数字范围检查和防止无限循环。</p>
<p>在__init__()函数中实现以下逻辑可能会带来问题。</p>
<pre><code>class ValidPlayer:
 　　def __init__( self, table, bet_strategy, game_strategy ):
 　　　　assert isinstance( table, Table )
 　　　　assert isinstance( bet_strategy, BettingStrategy )
 　　　　assert isinstance( game_strategy, GameStrategy )
 　　　　self.bet_strategy = bet_strategy
 　　　　self.game_strategy = game_strategy
 　　　　self.table= table</code></pre>
<p>这里使用了isinstance()函数检查了每个类型的合法性。</p>
<p>我们编写了玩牌游戏模拟器并通过不断地改变GameStrategy类来进行实验。由于它们都很简单（只有4个函数），继承的好处不够凸显，我们可以单独定义每个子类而不再定义基类。</p>
<p>正如本例中所演示的，我们将不得不创建子类，目的只是为了通过初始化过程的错误检查，而未能从抽象基类继承到任何可用的代码。</p>
<p>其中一个最大的鸭子类型问题是关于数值类型的，不同的数值类型会在不同的上下文工作。试图验证参数类型也许会导致原本工作很好的一个数值类型不再工作。当试图验证时，在Python中我们有以下两种选择。</p>
<ul>
<li>为不是很广泛的集合类型加验证。一旦代码不工作了我们将会知道本该允许使用的类型被禁止了。</li>
<li>针对相对广泛的集合类型，通常不考虑加验证，一旦代码不工作了我们将会知道我们使用了一个不允许使用的类型。</li>
</ul>
<p>这两点基本表达了相同的意思。代码某一天可能会无效，要么是因为一个本该允许的类型被禁止了，要么是使用了被禁止的类型。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2U0OWU2MzEwMmYwZTliYjMwOWFjZjc1YjRlMzJjYjU0Y2I3ZmUyNGQucG5n.jpg"></p>
<p>面临这样一个问题：为什么要限制未来潜在的使用场景？</p>
<p>而通常没有一个合理的理由来说明这一点。</p>
<p>为了不为以后的应用场景带来阻碍，可以考虑提供文档、测试和调试日志来帮助其他程序员理解哪些类型限制是可以被处理的。为了使工作量最小化，无论如何我们都必须提供文档、日志和测试用例。</p>
<p>以下是一段示例文档，用于说明类所需的参数。</p>
<pre><code>class Player:
 　　def __init__( self, table, bet_strategy, game_strategy ):
 　　　　"""Creates a new player associated with a table,
 　　　　　and configured with proper betting and play strategies
 　　　　:param table: an instance of :class:'Table'
 　　　　:param bet_strategy: an instance of :class:'BettingStrategy'
 　　　　:param game_strategy: an instance of :class:'GameStrategy'
 　　　　"""
 　　　　self.bet_strategy = bet_strategy
 　　　　self.game_strategy = game_strategy
 　　　　self.table= table</code></pre>
<p>当使用这个类时，就会从文档得知类的参数需求。可以传入任何类型。如果类型和期望的类型不兼容，那么代码将会不工作。理想情况下，我们会使用文档测试（doctest）和单元测试(unittest)来发现这些异常的场景。</p>
<h3>1.12.2　初始化、封装和私有化</h3>
<p>关于Python中的私有化可以概括为：大家都是成年人。</p>
<p>面向对象设计使得接口和实现有了很大的差别，这也是封装的意义。一个类封装了一种数据结构、一个算法和一个外部接口等，程序设计的目的是要把接口与实现分离。</p>
<p>然而，没有编程语言会暴露出所有设计的细节。对于Python，也是如此。</p>
<p>关于类设计的一个方面，这一点没有用代码演示：对象中有关私有（实现）和公有（接口）函数或属性的差异。有些编程语言只是在概念上支持私有（C++或Java是两个例子）已经很复杂了。这类语言中的访问修饰符包括了私有、保护、公有和“未指定”，可以理解为半私有。私有关键字经常被错误使用，为子类的定义带来了没必要的复杂性。</p>
<p>Python中私有的概念很简单，如下所示。</p>
<ul>
<li>基本都是公有。源代码随时可修改，大家都是成年人，没有什么是可以真正被隐藏的。</li>
<li>传统上，我们会使用命名来表明哪些不是完全公有的。它们通常是容易变化的具体实现细节，然而并不存在正式的、概念上的私有。</li>
</ul>
<p>Python中的部分函数以_命名，标记为不完全公有。help()函数通常会忽略这类函数。可以使用像Sphinx这样的工具从文档中查找出它们的命名。</p>
<p>Python的内部命名以__起始（和结尾）。这也是Python如何避免内部和外部应用程序发生冲突的方式。这些内部集合的命名方式完全只是参考。毕竟，没有必要在代码中试图使用__前缀来定义一个“超级私有”的属性或函数。如果这样做的话就为以后制造了一个潜在的麻烦，当新版本的Python发布并使用了同样命名的函数或属性时，就会有命名冲突。我们还有可能和新版本中的其他名称发生冲突。</p>
<p>Python中关于可见度的命名规则如下所示。</p>
<ul>
<li>大部分名称是公有的。</li>
<li>以_开始的名字通常不完全公有。使用它们来命名那些经常变化的函数，这些函数通常是实现细节。</li>
<li>以__作为前缀和后缀的函数通常是Python内部的。程序中不该使用；命名要参考编程语言的定义。</li>
</ul>
<p>通常，Python中的命名是根据函数（或属性）的目的来定义的，并提供文档说明。通常接口函数会有说明文档以及文档测试的例子，而实现细节的函数就不必了，提供简单的说明就可以了。</p>
<p>对于刚接触Python的程序员，有时会对私有化不是很常用而感到惊讶。可对于已经熟悉Python的程序员也会同样惊讶于，为了不必要的私有和公有定义的顺序而浪费很多脑细胞。因为函数名和文档已经把意图描述的很明白了。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 13:45:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b%e8%af%ad%e8%a8%80/" title="编程语言">编程语言</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1%e7%bc%96%e7%a8%8b/" title="面向对象编程">面向对象编程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Python面向对象编程指南》——1.12　更多的__init__()技术的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPLG0mp.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 本书主要介绍Python语言的高级特性,特别是如何编写高质量的Python程序.这通常意味着编写高性能且拥有良好可维护性的程序.同时,我们也会探究不同的设计方案并确定究竟是哪种方案提供了最佳性能.而对于一些正在寻找解决方案的问题,这也是一种很好的方式. 本书的大部分内容将介绍一种给定设计的不同替代方案.一些方案性能更好,另一些方案更加简单或者更加适合于特定领域的问题.最重要的是,找到最好的算法和最优的数据结构,以最少的开销换取最大的价值.时间就是金钱,高效的程序会为它们的用户创造更多的价			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJelq7p.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;5　通过工厂函数调用&lowbar;&lowbar;init&lpar;&rpar;&lowbar;&lowbar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 通过工厂函数调用__init()__ 我们可以使用工厂函数来完成所有Card对象的创建,这比枚举52张牌的方式好很多.在Python中,实现工厂有两种途径. 定义一个函数,返回不同类的对象. 定义一个类,包含了创建对象的方法.这是完整的工厂设计模式,正如设计模式书中提到的.在类似Java这样的语言里,工厂类层次结构是必需的,因为语言本身不支持可以脱离类而单独存在的函数. 在Python里,类定义不是必需的.仅当特别复杂的情形,工厂类才是不错的选择.Python的优势之一是,对于只需要简单			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK8NG5M.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;7　简单的组合对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.7 简单的组合对象 一个组合对象也可以称作容器.我们会从一个简单的组合对象开始介绍:一副牌.这是一个基本的集合对象.我们的确可以简单地使用一个list来代替一副牌(deck)对象. 在设计一个类之前,我们需要考虑这样的一个问题:简单地使用list是合适的做法吗? 可以使用random.shuffle()函数完成洗牌操作,使用deck.pop()来完成发牌操作. 一些程序员可能会过早定义新类,正如像使用内置类一样,违反了一些面向对象的设计原则.比如像下面的这个设计. d= [card6(r+1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQrE3WM.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;5　&lowbar;&lowbar;bytes&lowbar;&lowbar;&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.5 __bytes__()方法 只有很少的情景需要我们把对象转换为字节.在第2部分&quot;持久化和序列化&quot;中,我们会详细探讨这个主题. 通常,应用程序会创建一个字符串,然后使用Python的IO类内置的编码方法将字符串转换为字节.对于大多数情况,这种方法就足够了.只有当我们自定义一种新的字符串时,我们会需要定义这个字符串的编码方法. 依据不同的参数,bytes()函数的行为也不同. bytes(integer):返回一个不可变的字节对象,这个对象包含了给定数量的0x00值. bytes(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RQ1qz.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;第1部分 用特殊方法实现Python风格的类  第1章　&lowbar;&lowbar;init&lowbar;&lowbar;&lpar;&rpar;方法  1&period;1　隐式的基类&mdash;&mdash;object</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1部分 用特殊方法实现Python风格的类 init()方法 与Python无缝集成--基本特殊方法 属性访问.特性和修饰符 抽象基类设计的一致性 可调用对象和上下文的使用 创建容器和集合 创建数值类型 装饰器和Mixins--横切方面 用特殊方法实现 Python风格的类 通过重写特殊方法来完成对Python内部机制的调用,在Python中是很普遍的.例如len()函数就可以重写一个类的__len__()方法. 这意味着对于像(len(x))这样的通用公共接口,任何类(例如,声明一个类叫ti			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlWQXVb.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;9　new&lpar;&rpar;方法和元类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.9 new()方法和元类型 __new__()方法的另一种用途,作为元类型的一部分,主要是为了控制如何创建一个类.这和之前的如何用__new__()控制一个不可变对象是完全不同的. 一个元类型创建一个类.一旦类对象被创建,我们就可以用这个类对象创建不同的实例.所有类的元类型都是type,type()函数被用来创建类对象. 另外,type()函数还可以被用作显示当前对象类型. 下面是一个很简单的例子,直接使用type()作为构造器创建了一个新的但是几乎完全没有任何用处的类: Useless=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zePqWjp.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;3　&lowbar;&lowbar;hash&lowbar;&lowbar;&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 __hash__()方法 内置的hash( )函数默认调用了__hash__()方法.哈希是一种将相对复杂的值简化为小整数的计算方式.理论上说,一个哈希值可以表示出源值的所有位.还有一些其他的哈希方法,会得出非常大的值,这样的算法通常用于密码学. Python中有两个哈希库.其中,hashlib可以提供密码级别的哈希函数,zlib模块包含两个高效的哈希函数:adler32()和crc32().对于相对简单的值,我们不使用这些内置的函数,对于复杂的或者很大的值,这些内置的函数可以提供很大的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8k7Z9M.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;8　&lowbar;&lowbar;new&lowbar;&lowbar;&lpar;&rpar;方法和不可变对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.8 __new__()方法和不可变对象 __new__方法的一个用途是初始化不可变对象.__new__()方法中允许创建未初始化的对象.这允许我们在__init__()方法被调用之前先设置对象的属性. 由于不可变类的__init__()方法很难重载,因此__new__方法提供了一种扩展这种类的方法. 下面是一个错误定义的类,我们定义了float的一个包含单位信息的版本. class Float_Fail( float ): def __init__( self, value, unit ):			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjR6JM.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;2　&lowbar;&lowbar;format&lowbar;&lowbar;&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 __format__()方法 string.format()和内置的format()函数都使用了__format__()方法.它们都是为了获得给定对象的一个符合要求的字符串表示. 下面是给__format__()传参的两种方式. someobject.__format__(&quot;&quot;):当应用程序中出现format(someobject)或者&quot;{0}&quot;.format(someobject)时,会默认以这种方式调用__format__().在这些情况下,会传递一个空			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdm2zj.html" rel="bookmark" class="title">Photoshop制作噜友联盟字体标志教程</a>
					<div>
						   本教程主要使用Photoshop制作噜友联盟字体图标设计,主要通过图层样式来完成质感的表现,喜欢的朋友一起来学习吧.   分类: PS文字教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWljrp.html" rel="bookmark" class="title">瑞星&amp;amp&semi;amp&semi;360杀软行业之争</a>
					<div>
						近期看到了瑞星和360很多的新闻,其实这两个厂商在去年360推出免费杀毒后,就已经把很紧张的竞争关系甚至冲突不断升级.其实这两个厂商的人我都认识,也几次机会邂逅过两个公司的高层,感觉也都还不错的人,不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg85Bp.html" rel="bookmark" class="title">在C&num;中用最简洁有效的代码执行存储过程并返回数据</a>
					<div>
						存储过程|数据|执行 存储过程 p_sys_Login 定义如下: CREATE PROCEDURE p_sys_Login @argUserID varchar(20), --用户名 @argPas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp81Z3z.html" rel="bookmark" class="title">浅谈利用春节假期做好网站优化</a>
					<div>
						时间飞逝,转眼2011年已经过去,再过几天就是2012年春节了.过去的2011年,淘客人群中,可谓是有人收获多多,也有人甚至是颗粒无收吧.哈哈,当然我不否认更有一些沉默的高手月收入几万的大有人在的.近 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRROOz.html" rel="bookmark" class="title">google&plus;登录API使用javascript sdk快速入门图解教程</a>
					<div>
						准备工作: 打开Google API 控制台 : https://code.google.com/apis/console 点击 My Project (我的项目) 按照图示流程,您将完成一个goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYkQOb.html" rel="bookmark" class="title">Excel 2007中如何使工作表垂直并排查看</a>
					<div>
						  1.首先打开一份Excel工作表,单击&quot;视图&quot;选项卡,在&quot;窗口&quot;区域选择&quot;新建窗口&quot;选项组; 2.这时候你会发现在我们的桌面上会出现两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3jyEM.html" rel="bookmark" class="title">【MySQL】Could not initialize master info structure</a>
					<div>
						对一个M-M 架构的mysql 重新搭建双master ,出现了两个报错: ERROR 29 (HY000): File '/home/mysql/data3306/slave-relay.06653 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42ZO8M.html" rel="bookmark" class="title">iOS之UI--使用SWRevealViewController实现侧边菜单功能详解实例</a>
					<div>
						使用SWRevealViewController实现侧边菜单功能详解 下面通过两种方法详解SWRevealViewController实现侧边菜单功能: 1.使用StoryBoard实现 2.纯代码实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqXBBb.html" rel="bookmark" class="title">log4-Log4net不能输出日志文件的问题（在线等）</a>
					<div>
						问题描述 Log4net不能输出日志文件的问题(在线等) 新人初涉log4net,用了网上介绍的一种方法,LogBll下有以下修改log路径的函数 1 private void ChangeLog4n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvry0VM.html" rel="bookmark" class="title">高手请进！关于动态密码的问题</a>
					<div>
						问题描述 当用户在登录界面中输入ID,PSW,点击登录,客户端首先将密码进行MD5哈希运算,并将结果和本地存储的结果进行比较,如果不匹配就提示用户:然后发送请求session的消息,向服务器请求分配一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7JdZz.html" rel="bookmark" class="title">Android ICS关机跟重新启动功能研究</a>
					<div>
						Android ICS关机跟重新启动功能研究            最近研究了一下android关机跟重新启动功能.网上的文章也不少,做法也有一些.笔者试过了几种方法,下面介绍一下:   &lt;一& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRK78b.html" rel="bookmark" class="title">IBM在中国建设其第三座云计算数据中心</a>
					<div>
						数据中心主要用于云服务,致力于华北地区数字城市的发展,同时也将为IBM在亚洲地区的云计算业务提供动力支持,IBM一直都在构建全球云,创建智慧的地球,云计算数据中心的发展为IBM提供了更多的发展机遇.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKyA6b.html" rel="bookmark" class="title">vs调试时RadUpload正常，IIS中运行出错</a>
					<div>
						问题描述 在上传文件时,出现RadUploadContext.Current.UploadedFiles未将对象引用至实例,怎么回事? 解决方案 解决方案二: 解决方案三:自己顶一下,求高人帮忙解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmg8Wb.html" rel="bookmark" class="title">小冰从6月6日开始相继与米聊、易信、触宝号码助手达成战略合作</a>
					<div>
						摘要: 之前说到小冰一代产品在微博上活跃起来,用户可以在微博上@小冰并且与她聊天,提问,此外小冰从6月6日开始相继与米聊.易信.触宝号码助手达成战略合作.作为披着聊天机器人的 之前说到小冰一代产品在微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDer9Bb.html" rel="bookmark" class="title">让默认安装的Linux支持中文</a>
					<div>
						                                                                                          让默认安装的Linu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy8xxz.html" rel="bookmark" class="title">&period;net2005比&period;net2003强大之外在哪里&quest;</a>
					<div>
						问题描述 .net2005比.net2003强大之外在哪里? 解决方案 解决方案二:因为2005-2003&gt;0所以说能不强大吗?解决方案三:排版功能大大增强:P,很多增强的控件.使用起来更流畅, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRVBop.html" rel="bookmark" class="title">js-Highcharts问题&comma;如图所示</a>
					<div>
						问题描述 Highcharts问题,如图所示 我想去除Highcharts.com是需要替换掉我所引用的jQuery文件吗? 解决方案 自己也能采纳自己? 自己也能采纳自己? 自己也能采纳自己? 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvEVWM.html" rel="bookmark" class="title">科技影响教育 学生注意力难集中</a>
					<div>
						最近有调查显示,接近 90% 的教师认为数字化科技会将掠夺我们的注意力.60% 的学生也表示,他们的写作和面对面交流的能力都有所下降,近一半的学生承认他们的批判性思维和做作业的能力都受到了各种各样干扰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q6lBp.html" rel="bookmark" class="title">javascript使用switch case实现动态改变超级链接文字及地址&lowbar;javascript技巧</a>
					<div>
						代码很简单,我这里就不多废话了,小伙伴们直接看源码吧. 复制代码 代码如下: &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.01 Transiti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEDZOp.html" rel="bookmark" class="title">Python Tkinter基础控件用法&lowbar;python</a>
					<div>
						本文实例展示了Python Tkinter基础控件的用法,分享给大家供大家参考之用.具体方法如下: # -*- coding: utf-8 -*- from Tkinter import * def  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv9QWM.html" rel="bookmark" class="title">jQuery中show与hide方法用法示例&lowbar;jquery</a>
					<div>
						本文实例分析了jQuery中show与hide方法用法.分享给大家供大家参考,具体如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QX2Rp.html" rel="bookmark" class="title">微软必应与百度、谷歌的十点差异</a>
					<div>
						微软对搜索引擎市场这块蛋糕早已虎视眈眈垂涎三尺,看到谷歌.雅虎.百度等其他搜索日益成熟壮大,的确心急如焚,05年微软推出了MSN搜索,06年改成&quot;Windows Live搜索&quot;,都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWnWGz.html" rel="bookmark" class="title">百度长期不更新网站快照原因分析</a>
					<div>
						一.网站长期没有更新或者更新极度不规律 一个新网站在刚开始开通的时候,只要能基本上符合web标准,没有&quot;nofollow&quot;标签,无论当时是否收录,各大引擎的搜索蜘蛛肯定是频繁光临的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8rnVp.html" rel="bookmark" class="title">国庆中秋将至 短信传情成热点</a>
					<div>
						国庆中秋将至 短信传情成热点 &quot;中秋国庆喜相逢,万家团圆意相同.祝您节日快乐.合家团圆,心想事成,幸福一生&quot;!国庆中秋两大佳节还没有到来,温馨快乐的短信已经蔓延开了,从这些可以看出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYdOrb.html" rel="bookmark" class="title">实测北京WLAN：中电信认证繁琐移动网速最慢</a>
					<div>
						[通信产业网讯](记者 卢子月)虽然进入2011年以来,运营商已经开展了大规模WLAN建设,但与运营商百万级热点覆盖的目标相比,WLAN网络建设还处在初级阶段.认证方式.网络覆盖.网络速度将成为运营商 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvW4yM.html" rel="bookmark" class="title">ASPxGridView动态绑定数据源时排序&comma;分组&comma;分页等功能失效的解决办法</a>
					<div>
						问题描述 如题. 解决方案 解决方案二:MARK,坐个沙发.帮你顶一下解决方案三:手工排序.分组.分页,而且这样做灵活性大,自己也能够了解其机制解决方案四:数据源绑定就相当于是傻瓜照相机一样,就算你会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdDq8z.html" rel="bookmark" class="title">android4&period;4系统解决&OpenCurlyDoubleQuote;ERRORcouldn&amp;&num;039&semi;t find native method&rdquo;方法</a>
					<div>
						android4.4系统解决&quot;ERRORcouldn't find native method&quot;方法             今天笔者在移植一个tv模块从android4.2到an ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4Rv2b.html" rel="bookmark" class="title">ASP&period;NET页面间数据传递的方法</a>
					<div>
						00.引言 Web页面是无状态的, 服务器对每一次请求都认为来自不同用户,因此,变量的状态在连续对同一页面的多次请求之间或在页面跳转时不会被保留.在用ASP.NET 设计开发一个Web系统时, 遇到一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAdRap.html" rel="bookmark" class="title">谷歌将取代Yandex成为俄语版Firefox默认搜索</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6.58.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 当Firefox 14登陆俄罗斯市 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GOm4M.html" rel="bookmark" class="title">《Tableau数据可视化实战》&mdash;&mdash;2&period;3节创建条形图</a>
					<div>
						2.3 创建条形图条形图简单易懂,是最常见的图表类型.具有水平方向的图表称为&quot;条形图&quot;,具有垂直方向的图表称为&quot;柱状图&quot;.条形的长度代表一个特定度量的量.条形图 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
